from preprocessing import DATA_PATH

import pandas as pd

def create_output(vectorizer, model):
    sub_data = pd.read_csv(DATA_PATH / "test_without_labels.csv")
    X_test = vectorizer.transform(sub_data["Text"])

    test_preds = model.predict(X_test)

    # Map numeric codes back to the original string labels
    train_raw = pd.read_csv(DATA_PATH / "train_submission.csv")
    train_raw.drop(columns=["Usage"], inplace=True)
    train_raw["Label"] = train_raw["Label"].astype("category")
    categories = train_raw["Label"].cat.categories  # from your training set
    sub_data["Label"] = categories[test_preds]

    # Add an "ID" column if not present; otherwise use existing
    if "ID" not in sub_data.columns:
        sub_data.insert(0, "ID", range(1, len(sub_data) + 1))

    # Output only the desired columns to CSV
    sub_data[["ID", "Label"]].to_csv("submission.csv", index=False)