from sklearn.model_selection import GridSearchCV

def XGB_crossval(X_train,y_train,X_val,y_val, xgb_model):
                
    param_grid = {'n_estimators': [100],
                  'learning_rate': [0.1],
                  'max_depth': [1],
                  'subsample': [0.1],
                  'colsample_bytree': [0.1]}
    
    grid_search = GridSearchCV(estimator=xgb_model, param_grid=param_grid,
                           cv=2, scoring='accuracy', verbose=True, n_jobs=12)
    xgb_model.fit(X_train, y_train)
    #grid_search.fit(X_train, y_train)
    best_params = grid_search.best_params_
    print("Meilleurs hyperparamètres trouvés :", best_params)

    best_model = grid_search.best_estimator_
    validation_accuracy = best_model.score(X_val, y_val)
    print(f"Précision sur les données de validation : {validation_accuracy * 100:.2f}%")
